package dev.shadowsoffire.apotheosis.adventure.affix.salvaging;

import net.minecraft.world.level.block.entity.BlockEntity;
import net.minecraft.ChatFormatting;
import net.minecraft.world.item.TooltipFlag;
import net.minecraft.network.chat.Component;
import java.util.List;
import net.minecraft.world.level.BlockGetter;
import net.minecraft.world.item.ItemStack;
import dev.shadowsoffire.placebo.menu.MenuUtil;
import net.minecraft.world.InteractionResult;
import net.minecraft.world.phys.BlockHitResult;
import net.minecraft.world.InteractionHand;
import net.minecraft.world.entity.player.Player;
import dev.shadowsoffire.placebo.menu.SimplerMenuProvider;
import net.minecraft.world.MenuProvider;
import net.minecraft.core.BlockPos;
import net.minecraft.world.level.Level;
import net.minecraft.world.level.block.state.BlockState;
import net.minecraft.world.level.block.state.BlockBehaviour;
import net.minecraft.world.level.block.EntityBlock;
import net.minecraft.world.level.block.Block;

public class SalvagingTableBlock extends Block implements EntityBlock
{
    public SalvagingTableBlock(final BlockBehaviour.Properties properties) {
        super(properties);
    }
    
    public MenuProvider m_7246_(final BlockState pState, final Level pLevel, final BlockPos pPos) {
        return (MenuProvider)new SimplerMenuProvider(pLevel, pPos, SalvagingMenu::new);
    }
    
    public InteractionResult m_6227_(final BlockState state, final Level level, final BlockPos pos, final Player player, final InteractionHand hand, final BlockHitResult hit) {
        return MenuUtil.openGui(player, pos, SalvagingMenu::new);
    }
    
    public void m_5871_(final ItemStack pStack, final BlockGetter pLevel, final List<Component> list, final TooltipFlag pFlag) {
        list.add((Component)Component.m_237115_(this.m_7705_() + ".desc").m_130940_(ChatFormatting.GRAY));
    }
    
    public BlockEntity m_142194_(final BlockPos pPos, final BlockState pState) {
        return new SalvagingTableTile(pPos, pState);
    }
    
    @Deprecated
    public void m_6810_(final BlockState state, final Level world, final BlockPos pos, final BlockState newState, final boolean isMoving) {
        if (state.m_60734_() == this && newState.m_60734_() == this) {
            return;
        }
        final BlockEntity te = world.m_7702_(pos);
        if (te instanceof final SalvagingTableTile salvTile) {
            for (int i = 0; i < salvTile.output.getSlots(); ++i) {
                m_49840_(world, pos, salvTile.output.getStackInSlot(i));
            }
        }
        super.m_6810_(state, world, pos, newState, isMoving);
    }
}
